import { Construct } from 'constructs';
import { BedrockAgentProps } from './interfaces';
export declare class BedrockAgent extends Construct {
    private readonly agentName;
    private readonly instruction;
    private readonly foundationModel;
    private readonly agentResourceRoleArn;
    private readonly description;
    private readonly idleSessionTTLInSeconds;
    private readonly actionGroups;
    private readonly knowledgeBaseAssociations;
    private readonly bedrockAgentCustomResourceRole;
    /**
      * `agentId` is the unique identifier for the created agent.
      */
    readonly agentId: string;
    /**
      * `agentArn` is the ARN for the created agent.
      */
    readonly agentArn: string;
    constructor(scope: Construct, name: string, props: BedrockAgentProps);
    private getDefaultAgentResourceRoleArn;
    private attachS3BucketReadOnlyPolicy;
    private lambdaAttachResourceBasedPolicy;
    private getUndefinedActionGroup;
    private getUndefinedKnowledgeBase;
}
