import { Construct } from 'constructs';
import { BedrockKnowledgeBaseProps } from './interfaces';
export declare class BedrockKnowledgeBase extends Construct {
    private readonly region;
    private readonly name;
    private readonly roleArn;
    private readonly knowledgeBaseConfiguration?;
    private readonly storageConfiguration;
    private readonly dataSource;
    private readonly description?;
    private readonly removalPolicy?;
    private readonly bedrockKnowledgeBaseCustomResourceRole;
    /**
      * `knowledgeBaseId` is the unique identifier for the created knowledge base.
      */
    readonly knowledgeBaseId: string;
    /**
      * `knowledgeBaseArn` is the ARN for the created knowledge base.
      */
    readonly knowledgeBaseArn: string;
    /**
      * `dataSourceId` is the unique identifier for the created data source.
      */
    readonly dataSourceId: string;
    constructor(scope: Construct, name: string, props: BedrockKnowledgeBaseProps);
    private setKnowledgeBaseConfigurationDefaultValues;
    private setDataSourceDefaultValues;
}
